package model

import (
	"gorm.io/gorm"
)

type FsProduct struct {
	Id                   int64   `gorm:"primary_key" json:"id"`           //
	Sn                   *string `gorm:"-" json:"sn"`                     // 商品编号 P98f087j
	Type                 *int64  `gorm:"-" json:"type"`                   // 分类ID
	Title                *string `gorm:"-" json:"title"`                  // 名称
	TitleCn              *string `gorm:"-" json:"title_cn"`               // 中文名称
	Cover                *string `gorm:"-" json:"cover"`                  // 封面图
	Imgs                 *string `gorm:"-" json:"imgs"`                   // 一个或多个介绍图或视频
	Keywords             *string `gorm:"-" json:"keywords"`               // 关键字
	Intro                *string `gorm:"-" json:"intro"`                  // 简要描述
	Sort                 *int64  `gorm:"-" json:"sort"`                   // 排序
	SelledNum            *int64  `gorm:"-" json:"selled_num"`             // 已卖数量
	Ctime                *int64  `gorm:"-" json:"ctime"`                  // 添加时间
	View                 *int64  `gorm:"-" json:"view"`                   // 浏览量
	SizeIds              *string `gorm:"-" json:"size_ids"`               // 尺寸 1,2,3,4
	MaterialIds          *string `gorm:"-" json:"material_ids"`           // 材质 1,2,3
	TagIds               *string `gorm:"-" json:"tag_ids"`                // 标签 逗号间隔
	Status               *int64  `gorm:"-" json:"status"`                 // 状态位  弃用
	ProduceDays          *int64  `gorm:"-" json:"produce_days"`           // 生产天数
	DeliveryDays         *int64  `gorm:"-" json:"delivery_days"`          // 运送天数
	CoverImg             *string `gorm:"-" json:"cover_img"`              // 背景图
	IsShelf              *int64  `gorm:"-" json:"is_shelf"`               // 是否上架
	IsRecommend          *int64  `gorm:"-" json:"is_recommend"`           // 是否推荐
	IsHot                *int64  `gorm:"-" json:"is_hot"`                 // 是否热销
	IsProtection         *int64  `gorm:"-" json:"is_protection"`          // 是否环保
	IsMicrowave          *int64  `gorm:"-" json:"is_microwave"`           // 是否可微波炉
	IsDel                *int64  `gorm:"-" json:"is_del"`                 // 是否删除
	RecommendProduct     *string `gorm:"-" json:"recommend_product"`      // 推荐产品id例如: 1,3,4,5
	RecommendProductSort *string `gorm:"-" json:"recommend_product_sort"` // 推荐排序例如:1324
	SceneIds             *string `gorm:"-" json:"scene_ids"`              // 关联的场景id
}
type FsProductModel struct{ db *gorm.DB }

func NewFsProductModel(db *gorm.DB) *FsProductModel { return &FsProductModel{db} }
