package model

import (
	"gorm.io/gorm"
)

type FsProductPrice struct {
	Id            int64    `gorm:"primary_key" json:"id"`    //
	Sn            *string  `gorm:"-" json:"sn"`              // 唯一编码
	Title         *string  `gorm:"-" json:"title"`           // 标题描述
	ProductId     *int64   `gorm:"-" json:"product_id"`      // 产品ID
	MaterialId    *int64   `gorm:"-" json:"material_id"`     // 材质ID
	SizeId        *int64   `gorm:"-" json:"size_id"`         // 尺寸ID
	EachBoxNum    *int64   `gorm:"-" json:"each_box_num"`    // 每一箱的个数
	EachBoxWeight *float64 `gorm:"-" json:"each_box_weight"` // 每一箱的重量 单位KG
	MinBuyNum     *int64   `gorm:"-" json:"min_buy_num"`     // 最少购买量
	StepNum       *string  `gorm:"-" json:"step_num"`        // 数量阶梯 eg:10,20,30
	StepPrice     *string  `gorm:"-" json:"step_price"`      // 价格阶梯 eg:100,50,25
	Status        *int64   `gorm:"-" json:"status"`          // 是否可用
	IsDefault     *int64   `gorm:"-" json:"is_default"`      // 是否默认
}
type FsProductPriceModel struct{ db *gorm.DB }

func NewFsProductPriceModel(db *gorm.DB) *FsProductPriceModel { return &FsProductPriceModel{db} }
