package model

import (
	"gorm.io/gorm"
)

type FsQrcodeSet struct {
	Id           int64   `gorm:"primary_key" json:"id"`  // id
	Name         *string `gorm:"-" json:"name"`          // 二维码组件名称
	Size         *int64  `gorm:"-" json:"size"`          // 二维码内容尺寸
	IndexX       *int64  `gorm:"-" json:"index_x"`       // x偏移量
	IndexY       *int64  `gorm:"-" json:"index_y"`       // y偏移量
	SvgWebsite   *string `gorm:"-" json:"svg_website"`   // website d数据
	SvgInstagram *string `gorm:"-" json:"svg_instagram"` // svg instagram d数据
	SvgFacebook  *string `gorm:"-" json:"svg_facebook"`  // svg facebook d数据
	Status       *int64  `gorm:"-" json:"status"`        // 状态
	AdminId      *int64  `gorm:"-" json:"admin_id"`      // 操作人
	Ctime        *int64  `gorm:"-" json:"ctime"`         // 添加时间
	Utime        *int64  `gorm:"-" json:"utime"`         // 更新时间
}
type FsQrcodeSetModel struct{ db *gorm.DB }

func NewFsQrcodeSetModel(db *gorm.DB) *FsQrcodeSetModel { return &FsQrcodeSetModel{db} }
