// Code generated by goctl. DO NOT EDIT.
package types

import (
	"fusenapi/utils/basic"
)

type Request struct {
}

type RequestBasicInfoForm struct {
	FirstName            string `form:"first_name,optional" db:"first_name"`                         // FirstName
	LastName             string `form:"last_name,optional" db:"last_name"`                           // LastName
	Company              string `form:"company,optional" db:"company"`                               // 公司名称
	Mobile               string `form:"mobile,optional" db:"mobile"`                                 // 手机号码
	Email                string `form:"email" db:"email"`                                            // 邮箱
	Type                 int64  `form:"type,optional" db:"type"`                                     // 1正常 0不正常
	IsOrderStatusEmail   int64  `form:"is_order_status_email,optional" db:"is_order_status_email"`   // 订单状态改变时是否接收邮件
	IsEmailAdvertisement int64  `form:"is_email_advertisement,optional" db:"is_email_advertisement"` // 是否接收邮件广告
	IsOrderStatusPhone   int64  `form:"is_order_status_phone,optional" db:"is_order_status_phone"`   // 订单状态改变是是否接收电话
	IsPhoneAdvertisement int64  `form:"is_phone_advertisement,optional" db:"is_phone_advertisement"` // 是否接收短信广告
	IsOpenRender         int64  `form:"is_open_render,optional" db:"is_open_render"`                 // 是否打开个性化渲染（1：开启，0：关闭）
	IsLowRendering       int64  `form:"is_low_rendering,optional" db:"is_low_rendering"`             // 是否开启低渲染模型渲染
	IsRemoveBg           int64  `form:"is_remove_bg,optional" db:"is_remove_bg"`                     // 用户上传logo是否去除背景
}

type RequestUserLogin struct {
	Name     string `json:"name"`
	Password string `json:"pwd"`
}

type DataUserLogin struct {
	Token string `json:"token"` // 登录jwt token
}

type DataGuest struct {
	Token string `json:"token"` // 登录jwt token
}

type DataUserBasicInfo struct {
	Type                 int64 `json:"type"`                   // 1普通餐厅 2连锁餐厅
	IsOrderStatusEmail   bool  `json:"is_order_status_email"`  // 订单状态改变时是否接收邮件
	IsEmailAdvertisement bool  `json:"is_email_advertisement"` // 是否接收邮件广告
	IsOrderStatusPhone   bool  `json:"is_order_status_phone"`  // 订单状态改变是是否接收电话
	IsPhoneAdvertisement bool  `json:"is_phone_advertisement"` // 是否接收短信广告
	IsOpenRender         bool  `json:"is_open_render"`         // 是否打开个性化渲染（1：开启，0：关闭）
	IsThousandFace       bool  `json:"is_thousand_face"`       // 是否已经存在千人千面（1：存在，0：不存在）
	IsLowRendering       bool  `json:"is_low_rendering"`       // 是否开启低渲染模型渲染
	IsRemoveBg           bool  `json:"is_remove_bg"`           // 用户上传logo是否去除背景
}

type DataGetType struct {
	Id   int64  `db:"id" json:"key"`    // ID
	Name string `db:"name" json:"name"` // 餐厅名字
}

type KeyName struct {
	Key  int    `json:"key"`
	Name string `json:"name"`
}

type KeyNameButton struct {
	Key    int      `json:"key"`
	Name   string   `json:"name"`
	Button []string `json:"button"`
}

type DataStatusConfig struct {
	SearchList               []KeyName       `json:"search_list"`                //搜索下拉列表
	OrderStatus              []KeyNameButton `json:"order_status"`               //直邮单状态
	InventoryStatus          []KeyNameButton `json:"Inventory_status"`           //云仓单状态
	OrderLogisticsStatus     []KeyName       `json:"order_logistics_status"`     //订单物流状态
	InventoryLogisticsStatus []KeyName       `json:"Inventory_logistics_status"` //订单物流状态
	Time                     []KeyName       `json:"time"`                       //返回订单时间筛选项
	RefundReason             []KeyName       `json:"refund_reason"`              //退款原因说明项
	LogisticsStatus          []KeyNameButton `json:"logistics_status"`           //物流状态筛选项
}

type DataAddressList struct {
	Id        int64  `db:"id"`
	UserId    int64  `db:"user_id"`    // 用户ID
	Name      string `db:"name"`       // 地址名称
	FirstName string `db:"first_name"` // FirstName
	LastName  string `db:"last_name"`  // LastName
	Mobile    string `db:"mobile"`     // 手机号码
	Street    string `db:"street"`     // 街道
	Suite     string `db:"suite"`      // 房号
	City      string `db:"city"`       // 城市
	State     string `db:"state"`      // 州名
	ZipCode   string `db:"zip_code"`   // 邮编
	IsDefault int64  `db:"is_default"` // 1默认地址，0非默认地址
}

type Response struct {
	Code    int         `json:"code"`
	Message string      `json:"msg"`
	Data    interface{} `json:"data"`
}

type ResponseJwt struct {
	Code         int         `json:"code"`
	Message      string      `json:"msg"`
	Data         interface{} `json:"data"`
	AccessSecret string      `json:"accessSecret"`
	AccessExpire int64       `json:"accessExpire"`
}

type Auth struct {
	AccessSecret string `json:"accessSecret"`
	AccessExpire int64  `json:"accessExpire"`
	RefreshAfter int64  `json:"refreshAfter"`
}

// Set 设置Response的Code和Message值
func (resp *Response) Set(Code int, Message string) *Response {
	return &Response{
		Code:    Code,
		Message: Message,
	}
}

// Set 设置整个Response
func (resp *Response) SetWithData(Code int, Message string, Data interface{}) *Response {
	return &Response{
		Code:    Code,
		Message: Message,
		Data:    Data,
	}
}

// SetStatus 设置默认StatusResponse(内部自定义) 默认msg, 可以带data, data只使用一个参数
func (resp *Response) SetStatus(sr *basic.StatusResponse, data ...interface{}) *Response {
	newResp := &Response{
		Code: sr.Code,
	}
	if len(data) == 1 {
		newResp.Data = data[0]
	}
	return newResp
}

// SetStatusWithMessage 设置默认StatusResponse(内部自定义) 非默认msg, 可以带data, data只使用一个参数
func (resp *Response) SetStatusWithMessage(sr *basic.StatusResponse, msg string, data ...interface{}) *Response {
	newResp := &Response{
		Code:    sr.Code,
		Message: msg,
	}
	if len(data) == 1 {
		newResp.Data = data[0]
	}
	return newResp
}
